#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define VERSION "0.1.4"

char *parse(char *buf);
char buf2[1025];

int usage(char *prgname)
{
	fprintf(stderr,
		"Usage: %s <Inputfile|-> [<-o Outputfile>]\n"
		"\tInputfile\tFile to read Syslinux message "
		"from. Set \"-\" for\n\t\t\tstandard input.\n"
		"\t-o Outputfile\tFile to write to. If omitted, "
		"standard output is\n\t\t\tassumed.\n"
		"\t-h\t\tThis screen.\n\n", prgname);
	exit(0);
}


int main(int argc, char **argv)
{
	int c;
	FILE *in;
	FILE *out;
	char buf[1025];

	printf("mksysdisp %s\n(c) 2002 Peter Ludikovsky\n\n",VERSION);

	if (argc < 2)
		usage(argv[0]);

	if (argv[1][0] == '-' && argv[1][1] == '\0')
		in = stdin;
	else if ((in = fopen(argv[1], "r")) == NULL)
		in = stdin;
	out = stdout;
	while (1) {
		c = getopt(argc, argv, "ho:");
		if (c == -1)
			break;
		switch (c) {
		case 'h':
		case '?':
			usage(argv[0]);
			break;
		case 'o':
			if ((out = fopen(optarg, "w")) == NULL)
				out = stdout;
			break;
		}
	}
	while (1) {
		fgets(buf, 1025, in);
		if (buf[0] == '.' && buf[1] == '\n')
			break;
		parse(buf);
		fprintf(out, "%s", buf2);
	}
	fprintf(out, "%c", 26);
	fclose(out);
	fclose(in);
	return 0;
}

char *parse(char *buf)
{
	int i = 0, j = 0;

	for (i = 0; i < strlen(buf); i++) {
		if (buf[i] == '<' && buf[i + 1] == 'F' && buf[i + 2] == 'F'
		    && buf[i + 3] == '>') {
			buf2[j] = 12;
			i += 3;
		} else if (buf[i] == '<' && buf[i + 1] == 'S'
			   && buf[i + 2] == 'I' && buf[i + 3] == '>') {
			buf2[j] = 15;
			buf2[j + 1] = buf[i + 4];
			buf2[j + 2] = buf[i + 5];
			j += 2;
			i += 5;
		} else if (buf[i] == '<' && buf[i + 1] == 'I'
			   && buf[i + 2] == 'S' && buf[i + 3] == '>') {
			buf2[j] = 15;
			buf2[j + 1] = '0';
			buf2[j + 2] = '7';
			j += 2;
			i += 3;
		} else
			buf2[j] = buf[i];
		j++;
	}
	buf2[j] = 0;
	return buf2;
}
